import { Spin  } from 'antd';
import { useEffect, useState } from 'react';
import "./index.less";
// 实例存储
let menAction = {};
const MenLodingShow = (id,state={})=>{
  if(menAction[id]){
    menAction[id].show(state);
}else{
    console.warn (`MenLodingShow  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
}
}
const MenLodingClose = (id)=>{
  if(menAction[id]){
    menAction[id].close();
}else{
    console.warn (`MenLodingClose  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
}
}
const MenLoding = (props={})=>{
  let {id="",config={}} = props;
  let {title="loding..."} = config;
  let [state,setState] = useState(config.state||{});
  if(!menAction[id]){
    menAction[id] = {}
  }
  
  // 组件被销毁时必须销毁内存
  useEffect(()=>{
      return ()=>{
        delete menAction[id]
      };
  },[])
  menAction[id].show=(new_state={})=>{
    setState({...state,...new_state,visible:true});
  }
  menAction[id].close=()=>{
    setState({});
  }
  return <>
      {state.visible?<div className="men-example">
          <Spin tip={state.title?state.title:title}  />
      </div>:null}
  </> 
}
export const  menCreateMenLoding = (id,config)=>{
      return <MenLoding id={id} config={config}></MenLoding>
}
// const
export default {
  menCreateMenLoding,
  MenLodingShow,
  MenLodingClose
};