import React, { useEffect, useState ,useRef} from "react";
import { Modal, Button  ,Spin,Input} from 'antd';
import * as util from "../util";
import useMount from "../useMount";
import "./index.less"
// 数据仓库 
const action = {};
const menModalShow = (id,state)=>{
    if(action[id]){
        action[id].show(state);
    }else{
        console.warn (`menModalShow  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
    }
}
const menModalClose = (id)=>{
    if(action[id]){
        action[id].close();
    }else{
        console.warn (`menModalClose  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
    }
}
// 更改配置项
const menSetModalConfig = (id,con={})=>{
    if(action[id]){
        action[id].setConfig(con);
    }else{
        console.warn (`menSetModalConfig  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
    }
}
// setState
const menModalSetState = (id,con={})=>{
    if(action[id]){
        action[id].setState({...action[id].getState(),...con});
    }else{
        console.warn (`menSetModalConfig  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
    }
}
// 获取  state
const menModalGetState = (id)=>{
    if(action[id]){
        return action[id].getState();
    }else{
        console.warn (`menSetModalConfig  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
    }
}
// 设置modal loding 开启或者关闭
const menSetModalLoding = (id,flag)=>{
    if(action[id]){
        return action[id].setBaffle(flag);
    }else{
        console.warn (`menModalLoding  当前设置时机不对 实例不存在 或者 传入id ${id}错误 !Mendege`)
    }
}
const Footer = (props)=>{
    let {footer,state,setState} = props;
    if(state.footer){
        return state.footer instanceof Function?state.footer(state,setState):state.footer
    }
    if(footer){
        return footer instanceof Function?footer(state,setState):footer
    }else{
        return ""
    }
    
}
const Content = (props)=>{
    let {content,state,setState,refs} = props;
    if(state.content){
        return state.content instanceof Function?state.content(state,setState,refs):state.content
    }else{
        if(content){
            return content instanceof Function?content(state,setState,refs):content
        }else{
            return ""
        }
    }
    
    
}
// 创建弹窗  
/* 
    initiative_close:是否自动关闭弹窗  默认 true  自动关闭  modalConfig antd属性
    max  true false //开启最大弹窗  自适应屏幕
    refKeys refkey列表 晚些会提供一个方法 访问左右的refs
    useEffectState 每次state 更新以后的 钩子
    menUseEffEct 每次重新渲染后调用钩子 建议只在此处 操作dom
    noTitle 不需要title  暂未开发
    scope 作用域留存函数
*/
const MenCreateModalSon = ({id, configed = {}}) => {
    let newConfig = null;
    if(!action[id]){
        action[id] = {
            hisState:configed.state
        };
    }
    action[id].config = {...configed};
    let {config} = action[id];
    let [baffle,setBaffle] = useState(false);
    let [refresh,setRefresh] = useState(false);
    let [state,setState] = useState(config.state||{});
    let { 
    confirmClick,
    cancelClick,
    content,
    confirmLoading=false 
    ,modalConfig={},max,footer,style={},
    menUseEffEct=()=>{},
    useEffectState=()=>{},
    refKeys=[],
    scope={}
} = config;
    let refs = {};
    refKeys.forEach((i)=>{
        refs[i] = useRef()
    })
    useRef()
    useEffect(()=>{
        return ()=>{
            // 兼容苹果 暂时不回收 但是依然会重用内存
            // delete action[id]
        }
    },[]);
    useEffect(()=>{
        // 此处会强制设置body的高度 操作dom的方式
        if(config.menStyle){
            let menBodyDom = util.getClassNode(`.${id} .ant-modal-body`);
            if(menBodyDom&&menBodyDom[0]&&menBodyDom[0].style){
                util.absAcc(config.menStyle,(res)=>{
                    menBodyDom[0].style[res[0]] = res[1];
                })
            }
            
            // menBodyDom.style.height="200px";
            // menBodyDom.style.overflow="auto";
        }
        
        // document.querySelector(`.${id}`).style.height = 500;
        // 不支持再内部更改 state 只适合执行一些dom 操作
        let rescallback = menUseEffEct(state,refs);
        return rescallback
    })
    useEffect(useEffectState.bind(null,state),[state])
    let [visible,setVisible] = useState(state.show)
    const show = async (data)=>{

        if(!config.vir_loding){
            // await setBaffle(true)
            await setVisible(true);
            if(data){
                await setState({...state,...data})
            }
            // setTimeout(()=>{
            //     setBaffle(false)
            // },configed.lodingtime||300)
        }else{
            await setVisible(true);
            if(data){
                await setState({...state,...data})
            }
        }
        
    }
    const close = ()=>{
        setVisible(false)
        setState(action[id].hisState);
    }
    action[id].setConfig = (con)=>{
        if(con){
            action[id].config = {...action[id].config,...con}
            setRefresh(refresh?false:true)
        }else{
            // action[id].config = {...action[id].config,...con}
            setRefresh(refresh?false:true)
        }
        
    };
    action[id].setBaffle = setBaffle;
    action[id].setState = (con)=>{
        setState({...con})
        
    };
    action[id].getState = ()=>{
        return state;
        
    };
    action[id].show = (con)=>{
        show(con)
    };
    action[id].close = (con={})=>{
        close()
    };
    let modal_class = "mendege-modal";
    modal_class+=(" "+id);
    if(max){
        modal_class+=" mendege-modal-max"
    }
    let baffle_class = "baffle "
    if(baffle){
        baffle_class+=" _yes"
    }
    
    if(!visible){
        return null
    }
    let mFooter = {};
    if(footer||state.footer){
        mFooter = {
            footer:<Footer footer = {footer}  state={state} setState={setState}></Footer>
        }
    }
    return <>
        <div className = {baffle_class}>
            <Spin tip="Loading..." size="large" spinning={baffle} />
        </div>
        <Modal
        key={id}
    className = {modal_class}
    okText="确认"
    cancelText="取消"
    title={state.title||""}
    destroyOnClose={true}
    visible={visible}
    style = {style}
    onOk={()=>{
        if(state.confirmClick){
            state.confirmClick(state,scope)
        }else{
            confirmClick&&confirmClick(state,scope);
        }
        let {initiative_close=true} = action[id].config;
        initiative_close&&close();
        
    }}
    confirmLoading={confirmLoading}
    onCancel={()=>{
        let {initiative_close=true} = action[id].config;
        let isReturn = true;
        if(state.cancelClick){
            state.cancelClick(state);
        }else{
            cancelClick&&cancelClick(state)
        }
        if(cancelClick||state.cancelClick){
            isReturn = false;
        }

        if(initiative_close||isReturn){
            close()
        }
    }}
    transitionName=""
    {...modalConfig}
    {...mFooter}
  >
      <Content content={content} state={state} refs={refs} setState={setState}></Content>
    {/* {content instanceof Function?content(state,setState):content} */}
  </Modal>
    </>
}

const menCreateModal = (id,config)=>{
    return <MenCreateModalSon key={id} {...{id,configed:config}}></MenCreateModalSon>
}




export default {
    menCreateModal,
    menModalShow,
    menModalClose,
    menSetModalConfig,
    menModalSetState,
    menModalGetState,
    menSetModalLoding
}