/* eslint-disable */
import React from 'react'
import { Upload, message, Button } from 'antd';
import 'antd/dist/antd.css';
import './index.less'

const App =  (props: any) => {
  // 上传 方法
  const handleChange = (info:any) => {
    let fileList = [...info.fileList];
    
    // 1. Limit the number of uploaded files
    // Only to show two recent uploaded files, and old ones will be replaced by the new
    // fileList = fileList.slice(-2);
    if(info.file.status==="done"){
      fileList = fileList.map(file => {
        if (file.response&&file.response.data) {
            
          // Component will show file.url as link
          let res = file.response.data

          file.url = res.url;
        }
        if(file.xhr){
            delete file.xhr;
        }
      //   message.error("")
        return file;
      });
  
      
    }
    props.onChange(fileList);
  };
  
  return (
    <div className="huohua-x-form-container">
      <div style={{ margin: 24, }}>
      {props.disabled&&props.fileList.length===0?null:<Upload
      isImageUrl={()=>{
            return false
          }}
         disabled={props.page_status!=="apply"}
         listType="picture"
         multiple={true}
         withCredentials = {false}
         action={props.action}
         
         name={"file"}
         {...props}
         onChange = {handleChange}
         fileList={props.fileList}
        //  onPreview={async (data:any,daat2:any)=>{
        //    return <div>文件上传预览</div>
        //  }}
       >
         
          {props.disabled?<span>附件列表</span>:<Button>上传附件</Button>} 
       </Upload>}
      
      </div>
    </div>
  );
};

export default App;