
import { message } from 'antd';
/**
 * get
 * 树数据请求
 */
 export const getTreeData = (data:any)=>{
  // 81 
  let myWindow:any = window;
  if(myWindow.menRequest){
    return myWindow.menRequest
    .get(data.url,{
      params:data.params
    })
    .then((res:any) => {
      return res;
    })
    .catch((e:any) => {
      message.error(e?.message);
    });
}else{
  console.warn("windows 上 需要 全局变量 menRequest 作为 请求方法使用 可在挂载该方法前写入默认参数")
}
  
}

/**
 * 递归处理树节点数据
 */

 export const recursionTreeNode = (datas:any={
  newItems:{}
 })=>{
   let {data=[],newItems,title=""} = datas;
    // return list.map((node) => {
    //   if (node.key === key) {
    //     return { ...node, children };
    //   }
  
    //   if (node.children) {
    //     return { ...node, children: updateTreeData(node.children, key, children) };
    //   }
  
    //   return node;
    // });

    return data.map((i:any)=>{
      if(Array.isArray(i.children)&&i.children.length){
        // eslint-disable-next-line no-param-reassign
        newItems = {
          title:i.name||title,
          key:i.id?(i.id+""):"0",
          pid:i.pid+"",
          children:recursionTreeNode({
            data:i.children,
            newItems:{}
          })
        }
         
      }else{
        // eslint-disable-next-line no-param-reassign
        newItems = {
          title:i.name,
          key:i.id?(i.id+""):"0",
          pid:i.pid+"",
        }
      }
      return newItems;
    });
 }

