export const reqexCinfig = {
    // 只能输入 中文 英文 数字 下划线且不能以下划线开始
    numbers_chinese_english_underlined:  new RegExp(/^(?!_)(?!.*?_$)[a-zA-Z0-9_\u4e00-\u9fa5]+$/, "g"),
    english:new RegExp(/^[\da-z]+$/i, "g"),//只能输入英文
    cell_phone:/^[1][3,4,5,7,8][0-9]{9}$/,//手机号校验
    leading_trailing_spaces:/^\S.*\S$|(^\S{0,1}\S$)/gm,//首尾不能有空格
    number:/^[+-]?(0|([1-9]\d*))(\.\d+)?$/g,//只允许输入数字 
    // two_decimal_places:/^(?!0+(?:\.0+)?$)(?:[1-9]\d*|0)(?:\.\d{1,3})?$/g,//
    two_decimal_places:(n=2)=>{
        let str =`^(?!0+(?:\\.0+)?$)(?:[1-9]\\d*|0)(?:\\.\\d{1,${n}})?$` ;
        // "^\\(?"+"!0+(?:\//.0+)?$)(?:[1-9]\//d*|0)(?:\.\//d{1,"+n+"})?$/";

        return {
            t:new RegExp(str,"g"),
            s:`只允许输入${n}位小数`
        }
    },//一定位数的小数
    // 只能输入数字且为正数
    no_minus:/^\+?((0|([1-9]+\d*))|((0\.\d+)|([1-9]+\d*\.\d+)))$/g,
    //校验 只能特定的值才能通过
    through_specific:(a,title,IDmenAction,value)=>{
        // return "就是检验不通过",
        // // return new Promise((reslove,reject)=>{
        // //     reslove("123213");
        // // })
        if(a.specific.indexOf(value)>-1){
            IDmenAction.readOnlyValidator[title] = "";
            return "";
        }
        IDmenAction.readOnlyValidator[title] = a.message;
        return a.message;

    }
}