export const formData = {
    "name1":"王维焱",
    "name2":"163a12df-b2ed-11eb-aacd-9a208e8840ef",
    "name3":"预算申请",
} 

export const formMeta = {
    "type": "object",
    key:"myforms",
    editable:false,
    "properties": {
      "name1": {
        "title": "预算申请部门",
        readOnly:true,
        default:" ",
        "type": "string",
        "required": true,
        "x-component-props": {
          "allowClear": true
        },
        "name": "budgetDepartmentName",
        "key": "budgetDepartmentName",
        "x-component":"SearRefComponentBox"//SearRefComponentBox   ReferComponent
      },
      "name2": {
        "title": "是否预算内",
        "type": "string",
        "required": true,
        "x-component-props": {
          "allowClear": false
        },
        "name": "withinBudget",
        "key": "withinBudget",
        "x-component":"select",
        "enum": [
          {
            "value": "Y",
            "label": "是"
          },
          {
            "value": "N",
            "label": "否"
          }
        ],
      },
      "name3": {
        "title": "费用类型",
        "type": "string",
        // default:1,
        "required": true,
        "name": "expenseType",
        "key": "expenseType",
        "default": false,
        "x-component": "textarea"
      },
    },
    "ui:column": 3,
    "ui:displayType": "row",
    "ui:showDescIcon": true
};