固定计算规则 h_calculate
"x-component-props":{
    extension:{//扩展对象
            <!-- date_calculation 日期计算 初始日期 + 天数 -->
            <!-- together_select  一起选择 一对多 当选择某一个时 剩下的自动选择
                "source_value":{ldap:["email"]}, 同选规则 选择 ldap 会同时勾选 email 
            -->
            <!-- set_all_data  设置全表数据 更多出现在远端请求 目前给关联组件开发 会自动获取 参数 后续可能需要
                规范此处参数设置
                "request_url":"数据来源接口", 目前没有固定接口 先代码实现数据筛选
            -->
            "h_calculate":{//计算规则 
                <!-- type:"date_calculation",
                source:"c_effective_date,c_valid_time",
                message:"日期计算错误",//计算错误时提示语 -->
                type:"date_calculation",
                source:"c_effective_date,c_valid_time",
                message:"日期计算错误",//计算错误时提示语
            },
            checking_rule:"校验规则",//校验规则 在拥有计算规则时也会作为 标识规则存在 规则type会传入 如果还有校验规则 以,号分割 
            remote_calibration:"/ehr/exists-phone",//是否有远程校验 此处应该为地址
            <!-- 联动规则 分为即时联动和本地联动 主要负责显示隐藏 控制 不涉及到值的联动 -->
            linkage_agreement:{
                    <!-- 1.控制联动 某一项控制其他项 显示隐藏  -->
                    controls_other:{
                        valueKey:[],//当前表单项为 某某值 (valueKey)的时候 什么什么项([])显示 
                    }
            } 
}
}
数点位数
decimal_length
是否为条件变量
wr_condition
是否为查询变量
wr_query
是否自定义
wr_custom
是否卡片
wr_card; [""]
"className":"men-select-readonly" //当className的值包含 men-select-readonly 时 下拉多选不可搜索
certainly_readOnly :true 只要出现这个属性 那么 该字段在任何时候都不可编辑 视图也不能控制其编辑性 不过可控制其显隐

in_control:{key:{
    内部存储 是否是子表字段 是否 接受空值校验等等
    "wr_sub_list":true,//是否是子表字段
    "control_mode":"",//控制方式 分为 value 值控制 await_value 值范围（待选值）控制 show_hidden 显示隐藏控制 该参数 控制者和被控制者相同
    "sub_list_key":"c_son_form",//子表 key 
    "sub_list_column":"column3",// 属于子表那一列
    "key":"c_expenseType",//当前被控制者key
    "wr_null_check":true//是否被空值校验
    "whenValue":{//所有联动关系 在此处被备份 主要结构为 联动条件 wen ： 对应的当前值 
        "{{$self.value==1}}":[1]
    },
    
    }},是否控制者某些项  再子表中会用到 检查控制者是否有值 等等

being_control:[key:{
    内部存储 是否是主表字段 是否 接受空值校验等等 后续可能会加上远程校验等 如果某个子表里某个字段被控制 那么在这个子表的主要字段上也会有这个参数 不过对象内的属性 比较单一 只会有  wr_main_list  key
    "wr_main_list":true,//是否被主表控制
    "sub_main_key":"c_son_form",//主表key
    "key":"c_expenseType",//控制者key
    "wr_null_check":true,//是否接受空值校验
    }],是否被某些项控制者 主控方是否有值

xCp : x-component-props 
<!-- 日期组件 -->
xCp["wr_defaultValue"]==="taiyaki"  //taiyaki 默认值规则 taiyaki 当天
<!-- HuoHuaUploadBox 上传组件 -->
//       {
            //         "name": "Dingtalk_20210511171515.jpg",
            //         "thumbUrl": "预览地址",
            //         "uid": "/oa_form_budget/2021-06-30/1625034039042_Dingtalk_20210511171515.jpg",
            //         "url": "下载地址"
         }
<!-- AssociatedDocument 关联审批组件 -->
      {
                    "label":"预算事项审批绝对是大哥",
                    "value":"909912",
                    "status":"审批中",
                    "link":"详情地址",//链接
                    "icon":""
       }

       <!-- 主子表 -->

       主子表控制逻辑
       一、静态控制 A B（子表字段） 的值都是静态的 不存在远程值情况 远程需要新开发
       1. 谁控制谁 
       A 控制 B 分三种 可视逻辑展示 初步定为 首先选择某个表单项 然后选择要控制谁  下拉三值 对应下半部 
        1.控制显示隐藏
        2.控制待选值
        3.直接联动值 
        控制逻辑常规表单 模板
        A还可以控制B所在的列
        
        {
            type: "object",
            properties: {
                source: {
                type: "string",
                "x-component": "Input",
                "x-reactions": [
                    {
                    target: "expenseDetail",
                    when: "{{$self.value==11||$self.value==22}}",
                    fulfill: {
                        state: {
                        dataSource : [
                            {
                            label:"设置q1",
                            value:"设置2"
                            }
                        ]
                        }
                    },
                    otherwise: {
                        state: {
                        dataSource : [
                            {
                            label:"设置q2",
                            value:"设置2"
                            }
                        ]
                        }
                    }
                    }
                ]
                },
                "expenseDetail": {
                title:"12312",
                "default":"11",
                "type": "string",
                "required": true,
                "x-component-props":{
                    "extension":{
                        "son_title": "费用明细"
                    }
                },
                "name": "expenseDetail",
                "key": "expenseDetail",
                "x-decorator": "FormItem",
                "x-component": "Select",
                "enum": [
                    {
                        "value": "1",
                        "label": "是"
                    },
                    {
                        "value": "2",
                        "label": "否"
                    }
                ]
            }
            }
        }


        <!-- 主子表控制协议 -->

        {
  type: "object",
  properties: {
    source: {
      type: "string",
      "x-component": "Input",
      "x-reactions": [
        {
          target: "c_son_form.*.expenseDetail",
          when: "{{$self.value==11||$self.value==22}}",
          fulfill: {
            schema: {
              enum : [
                {
                  label:"设置q1",
                  value:"设置2"
                }
              ],
              'x-visible': false,

            }
          },
          otherwise: {
            schema: {
              enum : [
                {
                  label:"设置q2",
                  value:"设置2"
                }
              ],
              'x-visible': true,
            }
          }
        },
        {
          target: "c_son_form.column1",
          when: "{{$self.value==11||$self.value==22}}",
          fulfill: {
            schema: {
             
              'x-visible': false,

            }
          },
          otherwise: {
            schema: {
              'x-visible': true,
            }
          }
        }
      ]
    },
    "c_son_form": {
      "key": "c_son_form",
      'x-decorator': 'FormItem',
      'x-component': 'ArrayTable',
      "editable": true,
      "type": "array",
      "x-component-props": {
          "pagination": { "pageSize": 10 },
          "scroll": { "x": 960,"y":300 },
          "extension": {
              "button_config": {
                  "add": {
                      "key": "c_son_form_add",
                      "icon": "",
                      "popup": true
                  }
              }
          }
      },
      "items": {
          "type": "object",
          "properties": {
              "column1": {
                  "type": "void",
                  "x-component": "ArrayTable.Column",
                  "x-component-props": {
                      "title": "费用明细"
                  },
                  "properties": {
                      "expenseDetail": {
                        "default":"11",
                        "type": "string",
                        "x-component-props":{
                            "extension":{
                                "son_title": "费用明细"
                            }
                        },
                        "name": "expenseDetail",
                        "key": "expenseDetail",
                        "x-decorator": "FormItem",
                        "x-component": "Select",
                        "enum": [
                            {
                                "value": "1",
                                "label": "是"
                            },
                            {
                                "value": "2",
                                "label": "否"
                            }
                        ]
                    }
                  }
              },
              
          }
      },
      properties: {
        add: {
          type: 'void',
          'x-component': 'ArrayTable.Addition',
          title: '添加条目',
        },
      },
  }
  }
}


