import menGlobal from "../components/global";
import EditTable from "../components/EditTable/exports.js"
import Form from "../components/form/exports.js"
import Modal from "../components/Modal/exports.js"
import MenRender from "../components/MenRender/exports.js"
import MenLoding from "../components/MenLoding/exports.js"
import MenTree from "../components/MenTree/exports.js"
import {initConfig} from "./initConfig.js"
import menStore from "./menStore";
 export function createStore(reducer) {
    // 当前状态
    let currentState = initConfig;
    // 需要一些全局的方法 这个方法 怎么去调用呢
    function menComponents(){
      return {
          menStore,
          EditTable,
          Form,
          Modal,
          menGlobal,
          MenRender,
          MenLoding,
          MenTree
      }
    }
   
    // 返回的是个 store 对象
    return {menComponents}
  }