/* eslint-disable */
import React, {  useRef, useState } from 'react'
import 'antd/dist/antd.css';
import HuoHuaUpload from "../HuoHuaUpload";
import { Modal, Button } from 'antd';
import MenModal from "../../Modal/exports";
import Zoom from "./zoom"
const App = (props) => {
  const [isModalVisible, setIsModalVisible] = useState(false);
  const [iframeUrl, setIframeUrl] = useState("");
  const [title, setTitle] = useState("");
  const [imgUrl, setImgUrl] = useState("");
  const iframeRef = useRef();
  // const showModal = () => {
  //   setIsModalVisible(true);
  // };

  // const handleOk = () => {
  //   setIsModalVisible(false);
  //   setImgUrl("")
  // };

  // const handleCancel = () => {
  //   setIsModalVisible(false);
  //   // setIframeUrl("")
  //   setTitle("")
  //   setImgUrl("")
  // };

  const ModalBox = () => {
    return (
      <Modal
        style={{ height: "100%", width: "100%" }}
        // closable={false}
        title={title}
        width={"100%"}
        wrapClassName="HuoHuaUpload-preview-modal"
        visible={isModalVisible} onOk={handleOk} onCancel={handleCancel}
        footer={<div><Button type="primary" onClick={handleCancel}>关闭</Button></div>}
      >

        

      </Modal>
    );
  }
  return <div>
    {MenModal.menCreateModal("filePreview",{
      state:{
        title:"文件预览",
        url:"",
        imgUrl:""
      },
      max:true,
      refKeys:["imgurl"],
      menUseEffEct:(state,refs)=>{
        let zoom;
        if(state.imgUrl&&refs["imgurl"].current){
          let zoomEl = refs["imgurl"].current
          
          zoom = new Zoom({
            el:zoomEl,
            // options:{'top': zoomEl.offsetTop+50, 'left': zoomEl.offsetLeft+50, 'width': 400, 'height': 400 }
            options:{
            'top': 0, 
            'left': 0, 
            'width': zoomEl.offsetParent.clientWidth-20, 'height': zoomEl.offsetParent.clientHeight-20 }
          });
          zoom.setScale(1)
        }
        return ()=>{
          zoom&&zoom.destroy()
        }
      },
      content:(state,setState,refs)=>{
        let {imgUrl="",url=""} = state
          return imgUrl ? <div ref={refs["imgurl"]}><img  className="img_box"  
          src={imgUrl} alt="" /></div> :
          <iframe src={url} id="HuoHuaUpload-preview-iframe" frameBorder="0"
          style={{ width: "100%", height: "100%" }} ></iframe>
              
      },
      footer:<div><Button type="primary" onClick={()=>{
        MenModal.menModalClose("filePreview")
      }}>关闭</Button></div>
    })}
    <HuoHuaUpload
      accept={props.accept}
      headers={
        props.headers
      }
      setChange={(data= []) => {
        props.dispatch({
          type: 'budgetMatters/saveFormSingle',
          payload: {
            formData: { applyFileVos: [...data] }
          }
        });
      }}
      {...props}
      onPreview={(flie) => {
        let id = "";
        if (flie.response) {
          id = flie.response.data.uid;
        } else {
          id = flie.uid;
        }
        let flag = false;
        let jpgs = [".JPEG", ".jpeg", ".JPG", ".jpg", ".GIF", ".gif", ".BMP", ".bmp", ".PNG", ".png"];
        let turl = ""
        jpgs.some((i) => {
          
          if(flie.thumbUrl&&flie.thumbUrl.indexOf("http")>-1){
            turl = flie.thumbUrl;
          }else{
            turl = flie.response.data.thumbUrl;
          }
          if (turl.indexOf(i) != -1) {
            flag = true;
            return true;
          }
        })
        if (flag) {
          MenModal.menModalShow("filePreview",{
            imgUrl:turl,
            url:""
          })
          return;
        } else {
          MenModal.menModalShow("filePreview",{
            imgUrl:"",
            url:turl
          })
        }
        // request
        //   .get(baseUrl.concat('/file-manage/preview'), {
        //     params: { id: id }
        //   })
        //   .then((res) => {
        //     if (res && res.data) {
        //       // setIframeUrl(res.data)


        //       document.getElementById("HuoHuaUpload-preview-iframe").src = res.data;

        //       setTitle(flie.name);

        //     }
        //   })
        //   .catch((e) => {
        //     message.error(e?.message);
        //   });
      }}
      // listType= 'picture-card'
      showUploadList={{ 
        showDownloadIcon: ddUA.isMenPc, 
        showRemoveIcon: true, 
        // showPreviewIcon: false 
      }}
      onDownload={(flie)=>{
        window.location.href=flie.url;
        // request
        //   .get(baseUrl.concat('/form-manage-cos/get-config'), {
        //     params: { fileKey: flie.uid,fileName:flie.name }
        //   })
        //   .then((res) => {
            
        //     if (res && res.data) {
        //       let cos = new COS({
        //         SecretId:res.data.secretId,
        //         SecretKey:res.data.secretKey
        //       });
        //       cos.getObject({
        //         Bucket: res.data.bucketName, /* 必须 */
        //         Region: res.data.region,     /* 存储桶所在地域，必须字段 */
        //         Key: res.data.secretKey,  
        //      }, function(err, data) {
        //      });
        //       // setIframeUrl(res.data)




        //     }
        //   })
        //   .catch((e) => {
        //     message.error(e?.message);
        //   });
      }}
      

    >
    </HuoHuaUpload>
  </div>;
};
App.defaultProps = {
  fileList:[],//上传文件列表
  action:"",//上传地址 
  headers:{
    // accesstoken: authenticationLogin && authenticationLogin.getToken() || "",
    // "huohua-podenv": "1196",
    // "debug-param" : "wangweiyan@huohua.cn"
    "huohua-podenv": "HIS-1876"
  },//请求时往headers 里写入的内容
  accept:[".pptx", ".ppt", ".pot", ".potx", ".pps", ".ppsx", ".dps", ".dpt", ".pptm", ".potm", ".ppsm",
  ".xls", ".et", ".xlsx", ".doc", ".dot", ".wps", ".wpt", ".docx", ".dotx", ".docm", ".dotm", ".pdf", ".lrc",
  ".c", ".cpp", ".h", ".asm", ".s", ".java", ".asp", ".bat", ".bas", ".prg", ".cmd", ".rtf", ".txt",
  ".log", ".xml", ".htm", ".html", ".JPEG", ".jpeg", ".JPG", ".jpg", ".GIF", ".gif", ".BMP", ".bmp", ".PNG", ".png"],//支持文件类型
  setChange:()=>{//上传后事件  需要反向处理

  },
  onPreview:()=>{//预览方法

  }
}
export default App;