
import React, {useContext, useReducer, useLayoutEffect} from "react";
import {Context} from "./menCreate.js"
const uid = 0;
export const menConnect = (
mapStateToProps = state => state    //默认是一个方法 该参数返回数据会传入组件的props
) => WrappendComponent => props => {  // WrappendComponent 是受益的组件
  const store = useContext(Context)
  const {menComponents} = store
  const stateProps = mapStateToProps() //获取需要的props
  //将props 映射到组件内 完成connect方法的任务
  return <WrappendComponent {...props} {...stateProps} menComponents = {menComponents()} key ={uid+1} />
}


